Index: /other-projects/is-sheet-music-encore/trunk/image-identification-development/src/Main.java
===================================================================
--- /other-projects/is-sheet-music-encore/trunk/image-identification-development/src/Main.java	(revision 33323)
+++ /other-projects/is-sheet-music-encore/trunk/image-identification-development/src/Main.java	(revision 33324)
@@ -1,2 +1,60 @@
+/*
+                StartAndEndPoint l1 = parseArray[i];
+                StartAndEndPoint l2 = parseArray[i+ 1];
+                //CHECK WHICH line starts after the other
+                //If l1 is starting after, then comparisons are based around l1.s
+                //System.out.println("l1: " + l1.getP1().x);
+                //System.out.println("l2: " + l2.getP1().x);
+
+                System.out.println("1.0: L1S: " + l1.getP1().x + " larger than L2S: " + l2.getP1().x);
+                if(l1.getP1().x > l2.getP1().x) {
+                    System.out.println("1.1: Comparing L1S: " + l1.getP1().x + " less than L2E: " + l2.getP2().x);
+                    if (l1.getP1().x < l2.getP2().x) {
+                        //AND
+                        System.out.println("1.2: Comparing L1S: " + l1.getP1().x + " larger than L2S: " + l2.getP1().x);
+                        if (l1.getP1().x > l2.getP1().x) {
+                            System.out.println("1: Success. NEXT");
+                            //IT IS INTERSECTED
+                            continue;
+                        }
+                        else {
+                            //FAILED SECOND COMPARISON
+                            System.out.println("1: Fail");
+                        }
+                    }
+                    else {
+                        System.out.println("Checking other line");
+                    }
+                    System.out.println("2.0: L2S: " + l2.getP1().x + " larger than  L1S: " + l1.getP1().x);
+                }
+                //If l2 is starting after, then comparisons are based around l2.s
+                else if(l2.getP1().x > l1.getP1().x) {
+                    System.out.println("2.1: Comparing L2S: " + l1.getP1().x + " less than L1E: " + l2.getP2().x);
+                    if (l2.getP1().x < l1.getP2().x) {
+                        //AND
+                        System.out.println("2.2: Comparing L2S: " + l2.getP1().x + " larger than L1S: " + l1.getP1().x);
+                        if (l2.getP1().x > l1.getP1().x) {
+                            System.out.println("2: Success");
+                            //IT IS INTERSECTED
+                            //continue;
+                        }
+                        else {
+                            //FAILED SECOND COMPARISON
+                            System.out.println("2: Fail");
+                            //return false;
+                        }
+                    }
+                    else {
+                        System.out.println("Failed second comparison RETURN FALSE");
+                        return false;
+                    }
+                    //return false;
+                }
+                else{
+                    System.out.println("NEITHER RETURN FALSE");
+                    return false;
+                }
+  */
+
 import org.opencv.core.*;
 import org.opencv.core.Point;
@@ -12,4 +70,5 @@
 import java.util.Collection;
 import java.util.Collections;
+import java.util.Comparator;
 import javax.imageio.ImageIO;
 
@@ -22,4 +81,6 @@
 //https://www.programiz.com/java-programming/examples/standard-deviation
 //https://www.geeksforgeeks.org/how-to-remove-duplicates-from-arraylist-in-java/
+//https://stackoverflow.com/questions/7988486/how-do-you-calculate-the-variance-median-and-standard-deviation-in-c-or-java/7988556
+//https://stackoverflow.com/questions/10396970/sort-a-list-that-contains-a-custom-class
 
 
@@ -43,5 +104,4 @@
 
 public class Main {
-
     //DEPENDENT FUNCTIONS AND CLASSES
     static class StartAndEndPoint {
@@ -101,6 +161,5 @@
         //DIRECTLY COPIED//DIRECTLY COPIED//DIRECTLY COPIED//DIRECTLY COPIED//DIRECTLY COPIED//DIRECTLY COPIED
     }
-    public static double StandardDeviation(double parseArray[])
-    {
+    public static double StandardDeviation(double parseArray[]) {
 
         double mean;
@@ -121,6 +180,45 @@
 
     }
+    public static Boolean ClusterCheck(StartAndEndPoint parseArray[]){
+        System.out.println("LENGTH: " + parseArray.length);
+        //MAKE THREE COMPARISONS
+        //After clusters have been found.
+        //Check if  their x positions intersect
+        //Logic being
+        //(L1.S < L2.E && L1.S > L2.S)
+        //or
+        //(L2.S < L1.E && L2.S > L1.S)
+        //Variance is using Start of line point.
+        //USING VARIANTS
+        double sum =0;
+        double temp =0;
+        double mean, variance;
+        int size = parseArray.length;
+        //Calculate sum of array
+        for(int i =0; i < parseArray.length; i++){
+            sum += parseArray[i].getP1().y;
+        }
+        //Calculate mean of array
+        mean = sum/parseArray.length;
+        //Calculate variants
+        for(int i =0; i < size; i++){
+            temp += Math.pow((parseArray[i].getP1().y-mean),2);
+        }
+        variance = Math.abs(temp/(size -1));
+        System.out.println("VARIANCE: " + variance);
+        if(variance <= CLUSTER_DISTANCE_MAX && variance > CLUSTER_DISTANCE_MIN){
+            for(int i = 0; i < 3; i++){
+                double l1_S = parseArray[i].getP1().x;
+                double l1_E = parseArray[i].getP2().x;
+                double l2_S = 
+
+            }
+        }
+        return false;
+    }
 
     //GLOBAL_CONSTANTS
+    static double CLUSTER_DISTANCE_MAX      = 15;
+    static double CLUSTER_DISTANCE_MIN      = 2;
     static int CLASSIFIER_HOUGHLINESP_MIN 	= 10;
     static int CLASSIFIER_HOUGHLINESP_MAX 	= 65;
@@ -128,5 +226,5 @@
     static int STANDARD_DEVIATION_THRESHOLD = 6;
     static int MINLINECOUNT                 = 40;
-    static double MAXLINEGAP              	= 1;  //4
+    static int MAXLINEGAP              	    = 1;  //4
     static double SLOPEGRADIENT			  	= 0.02;
     //SHOULD TURN INTO ARGS
@@ -265,4 +363,9 @@
 
         /*
+        ADDITION:
+        After clusters have been found.
+        Check if x positions intersect at all
+            StartXPos of p1
+
         This will check for a cluster of lines that are close together.
         1. Go through the list of Y positions(start point) in parsed array.
@@ -307,4 +410,5 @@
                             if(linePointsArray.get(j).getP1().y != linePointsArray.get(i).getP1().y){
                                 closeLineYPos.add(linePointsArray.get(j).getP1().y);
+
                             }
                         }
@@ -325,5 +429,14 @@
                 //Sort array and remove duplicates
                 Collections.sort(closeLineYPos);
+
+
+
                 closeLineYPos = removeDuplicates(closeLineYPos);
+
+                //DISPLAYING AS EXCEPTED! WOO!
+
+                for (double y : closeLineYPos){
+                    System.out.println("CloseLineYPos: " + y);
+                }
                 if(closeLineYPos.size() >= 4) {
                     //FOR every item in array of CloseLines
@@ -334,5 +447,6 @@
                         }
                         else{
-                            //Add 4 values of Close Line Array to a tempArray
+
+                            //Add 4 values of CloseLine Array to a tempArray
                             double[] tempArray = new double[4];
                             tempArray[0] = closeLineYPos.get(i);
@@ -344,7 +458,8 @@
                             //If it SD is less than 5 then it is considered to be a cluster of lines.
 
+
                             if(StandardDeviation(tempArray) < STANDARD_DEVIATION_THRESHOLD){
-                                System.out.println("tempArray PT: "+tempArray[0] + " , " + tempArray[1] + " , " + tempArray[2] + " , " + tempArray[3]);
-                                System.out.println("tempArray SD: " + StandardDeviation(tempArray));
+                                //System.out.println("tempArray PT: "+tempArray[0] + " , " + tempArray[1] + " , " + tempArray[2] + " , " + tempArray[3]);
+                                //System.out.println("tempArray SD: " + StandardDeviation(tempArray));
                                 //Store array
                                 clusterArray.add(tempArray);
@@ -352,10 +467,10 @@
                                 //Go down +4 positions in closeLineYPos array
                                 if((i + 4 < closeLineYPos.size())){
-                                    System.out.println("IF, i = " + i + " -> "+ (i+4) + ", CloseLineYpos size= " + closeLineYPos.size());
+                                    //System.out.println("IF, i = " + i + " -> "+ (i+4) + ", CloseLineYpos size= " + closeLineYPos.size());
                                     i = i+4;
                                 }
                                 else{
                                     //break
-                                    System.out.println("ELSE, i = " + i+ " closeLineYpos size= " + closeLineYPos.size());
+                                    //System.out.println("ELSE, i = " + i+ " closeLineYpos size= " + closeLineYPos.size());
                                     Thread.sleep(2000);
                                     break;
@@ -413,4 +528,161 @@
     }
 
+    private static ArrayList ClassifierLineClusterPt(ArrayList<StartAndEndPoint> linePointsArray, Mat clustersFoundRGB){
+        /*
+        ADDITION:
+        This will check for a cluster of lines that are close together.
+        1. Go through the list of Y positions(start point) in parsed array.
+            If, there is a small distance between them,
+                then, add to closeLineArray.
+
+        Have all Y positions that are close to each other now.
+        Need to find the lines that are clustered together.
+
+        Now check if there are four of these are close to each other.
+        2.  Go through list of closeLine.
+                Get first four lines, traversing down a step each iteration {0,1,2,3} -> {1,2,3,4} -> {2,3,4,5}
+                If, those 4 lines are close together,
+                    Then, add them to a new array that holds Line Cluster Values.
+                    Go to line 4 positions down since, as do not want duplicates.
+
+        3.
+        */
+        ArrayList returnArray = new ArrayList();
+        ArrayList<StartAndEndPoint> closeLinePts = new ArrayList();
+        ArrayList<StartAndEndPoint[]> clusterPtArray = new ArrayList();
+        int clusterCount = 0;
+        try {
+            if(linePointsArray.size()> 1) {
+                /*
+                //Display input array TESTING PURPOSES
+                for (int i = 0; i < linePointsArray.size(); i++) {
+                    System.out.println(linePointsArray.get(i).toString());
+                }
+                */
+                //1. Check if y points are close together
+                //go thru list and compare values against each other
+                for (int i = 0; i < linePointsArray.size(); i++){
+                    //System.out.println("i: "+ linePointsArray.get(i).getP1().y);
+                    for (int j = 0; j < linePointsArray.size(); j++) {
+                        //System.out.println("j: "+ linePointsArray.get(j).getP1().y);
+                        //Check if difference is less than 4 and the values are not duplicates.
+                        if(Math.abs(linePointsArray.get(j).getP1().y - linePointsArray.get(i).getP1().y) < 5){
+                            if(linePointsArray.get(j).getP1().y != linePointsArray.get(i).getP1().y){
+                                closeLinePts.add(linePointsArray.get(i));
+                            }
+                        }
+                    }
+                }
+                /*for (double num : closeLineYPos){
+                      System.out.println(num);
+                } */
+
+                //2. Now check if there are four of these are close to each other.
+                //Go through all of the items in this list and check if four of them are close together
+                //Check first four items, traverse down a step {0,1,2,3} -> {1,2,3,4} -> {2,3,4,5}
+                //If 4 items are close together,
+                //Then add them to a new array that holds Line Cluster Values.
+                //Go down 4 positions down since, as do not want duplicates.
+
+                //Now have an array of at least four lines that are close together.
+                //Sort array and remove duplicates
+                Collections.sort(closeLinePts, new Comparator<StartAndEndPoint>() {
+                    @Override
+                    public int compare(StartAndEndPoint p1, StartAndEndPoint p2) {
+                        return (int)(p1.getP1().y - p2.getP1().y);
+                    }
+                });
+                closeLinePts = removeDuplicates(closeLinePts);
+                /*DISPLAYING AS EXCEPTED! WOO!
+                for (StartAndEndPoint pt : closeLinePts) {
+                    System.out.println("CloseLinePTs: " + pt.getP1().y);
+                }
+                */
+
+                if(closeLinePts.size() >= 4) {
+                    //FOR every item in array of CloseLines
+                    for(int i= 0; i< closeLinePts.size(); i++){
+                        //If last comparator is at end of array.
+                        if(i + 4 >= closeLinePts.size()){
+                            break;
+                        }
+                        else{
+                            //Add 4 values of CloseLinePt Array to a tempArray
+                            StartAndEndPoint[] tempPtArray = new StartAndEndPoint[4];
+                            tempPtArray[0] = closeLinePts.get(i);
+                            tempPtArray[1] = closeLinePts.get(i + 1);
+                            tempPtArray[2] = closeLinePts.get(i + 2);
+                            tempPtArray[3] = closeLinePts.get(i + 3);
+
+                            //Check standard deviation between these 4 values.
+                            //If it SD is less than 5 then it is considered to be a cluster of lines.
+                            if(ClusterCheck(tempPtArray)){
+                                //System.out.println("tempArray PT: "+tempArray[0] + " , " + tempArray[1] + " , " + tempArray[2] + " , " + tempArray[3]);
+                                //System.out.println("tempArray SD: " + StandardDeviation(tempArray));
+                                //Store array
+                                clusterPtArray.add(tempPtArray);
+                                //If I + 4 is less than the size of the array then increment by 4
+                                //Go down +4 positions in closeLineYPos array
+                                if((i + 4 < closeLinePts.size())){
+                                    //System.out.println("IF, i = " + i + " -> "+ (i+4) + ", CloseLineYpos size= " + closeLineYPos.size());
+                                    i = i+4;
+                                }
+                                else{
+                                    //break
+                                    //System.out.println("ELSE, i = " + i+ " closeLineYpos size= " + closeLineYPos.size());
+                                    Thread.sleep(2000);
+                                    break;
+                                }
+                            }
+                        }
+                    }
+                }
+                /*
+                System.out.println("Cluster Coordinates: ");
+                for(double[] items : clusterArray){
+                    for(int i = 0; i <items.length; i++){
+                        System.out.println("ITEMS: "+ items[i]);
+                    }
+                }
+                */
+                //Setup Drawing clusters found.
+                //For every pt given the input array
+                for(StartAndEndPoint pt : linePointsArray){
+                    //Go through every the Arrays in the clusterArray(clustered lines)
+                    for(int i =0; i < clusterPtArray.size(); i++){
+                        //Go through every item in the array
+                        for(StartAndEndPoint item : clusterPtArray.get(i)) {
+                            //Check if the curr item is equal to current pt
+                            if (item.getP1().y == pt.getP1().y){
+                                //calculate a different colour for each line
+                                //Draw a line
+                                Imgproc.line(clustersFoundRGB, pt.getP1(), pt.getP2(), new Scalar(0, 255, 0), 1, Imgproc.LINE_4, 0);
+                            }
+                        }
+                    }
+
+                }
+
+                clusterCount = clusterPtArray.size();
+                //SETUP RETURN ARRAY
+                if(clusterCount >= 1){
+                    returnArray.add(true);
+                    returnArray.add(closeLinePts.size());
+                    returnArray.add(clusterCount);
+                    returnArray.add(clustersFoundRGB);
+                }
+                else{
+                    returnArray.add(false);
+                    returnArray.add(closeLinePts.size());
+                    returnArray.add(clusterCount);
+                }
+            }
+        }
+        catch (Exception e) {
+            System.err.println(e);
+        }
+        return returnArray;
+    }
+
 
 
@@ -435,8 +707,8 @@
 
             //System.out.println(default_file);
-            //String default_file = "TestImages/NotSheetMusic01.png";
+            String default_file = "TestImages/NotSheetMusic01.png";
             //String default_file = "TestImages/NotSheetMusic02.png";
             //String default_file = "TestImages/SheetMusic01.png";
-            String default_file = "TestImages/SheetMusic02.png";
+            //String default_file = "TestImages/SheetMusic02.png";
             //String default_file = "TestImages/vLine.png";
             String filename = ((args.length > 0) ? args[0] : default_file);
@@ -461,5 +733,5 @@
 
             Imgproc.HoughLinesP(edgesDetected, linesP, 1, Math.PI / 720, HOUGHLINEP_THRESHOLD, minLineLength,MAXLINEGAP); // runs the actual detection
-            System.out.println("Before Gradient Filtering num lines: " + linesP.rows());
+            //System.out.println("Before Gradient Filtering num lines: " + linesP.rows());
 
             // Draw the lines
@@ -489,6 +761,6 @@
             //HighGui.imshow("Source", original);
             //HighGui.imshow("Just Edges", justEdges); //TESTING
-            HighGui.imshow("Detected Lines (in red) - positive", edgesDetectedRGB);
-            if(ClassifierLineCluster(pointArrayList, clustersFoundRGB).get(3) != null) {
+            //HighGui.imshow("Detected Lines (in red) - positive", edgesDetectedRGB);
+            if(ClassifierLineClusterPt(pointArrayList, clustersFoundRGB).get(3) != null) {
                 HighGui.imshow("CLUSTERS FOUND", clustersFoundRGB);
             }
@@ -499,6 +771,6 @@
             //System.out.println("LINE COUNT RESULT:   " +  ClassifierLineCount(horizontalLineCount) + '\t' +"LineCount: " + horizontalLineCount); //COUNT OF LINES CLASSIFICATION
             //System.out.println("LINE CLUSTER RESULT: " +  ClassifierLineClusterOLD(toBeClassifiedImg).get(0) + '\t' + "LinesFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(1) + '\t' + "ClustersFound: " + ClassifierLineClusterOLD(toBeClassifiedImg).get(2));
-            System.out.println("NEW CLUSTER RESULTS: " +  ClassifierLineCluster(pointArrayList,clustersFoundRGB).get(0) + '\t' + "LinesFound: " + ClassifierLineCluster(pointArrayList,clustersFoundRGB).get(1) + '\t' + "ClustersFound: " + ClassifierLineCluster(pointArrayList,clustersFoundRGB).get(2));
-            //System.out.println(ClassifierLineCluster(pointArrayList, clustersFoundRGB));
+            //System.out.println("NEW CLUSTER RESULTS: " +  ClassifierLineCluster(pointArrayList,clustersFoundRGB).get(0) + '\t' + "LinesFound: " + ClassifierLineCluster(pointArrayList,clustersFoundRGB).get(1) + '\t' + "ClustersFound: " + ClassifierLineCluster(pointArrayList,clustersFoundRGB).get(2));
+            System.out.println(ClassifierLineClusterPt(pointArrayList, clustersFoundRGB));
 
             // Wait and Exit
